{
  Modul Czytnik programu iTiczer.
  Zawiera procedure odpowiedzialna za wprowadzanie jedno liniowych tekstow.
  Procedura ta jest podobna do precedury Read biblioteki Crt
  zawiera jednak niezbedne rozszerzenia:
  * stworzenie odpowiedniego okna wprowadzania tekstu
  * tekst nie wychodzi poza okno, zmienna nie wzrasta ponad dlogosc okna
  * przemapowanie klawiatury do urzycia niemieckich znakow
  * obsluga podstawowej edycji:
        Kursory - przemieszczanie sie po tekscie
        Heme, End - poczatek, koniec tekstu
        Backspace - kasowanie jednego znaku przed kursorem
        Del - kasowanie calego dotychczasowego tekstu
  * wymienny parametr przerwania zapewnia rozne nozliwosci wyjscia
    z procedury np. zatwierdzenie lub rezygnacja
  * dodatkowy paramert dzieki ktoremu mozna wybrac czy dany tekst
    jest nazwa pliku; dzieki temu nie bedzie moza wpisywac znakow
    nieakceptowanych w nazwach plikow
}


Unit Czytnik;


 Interface
{=========}

Uses Crt, Podstawa, Paski;

Procedure Czytaj (x, y, l : byte; var lancuch: String;
                  var przerwanie: Byte; rodzaj: Byte);

 Implementation
{==============}

Procedure Czytaj (x, y, l : byte; var lancuch: String;
                  var przerwanie: Byte; rodzaj: Byte);
{   <x> i <y>: wspolzedne poczatka lini;
    <l>: dlugosc lini.
         po przekroczeniu nie czyta wiecej znakow choc nie przerywa
         dzialania procedury, tzn. dalej mozna poruszac sie
         strzalkami oraz kasowac teks Backspacem
    <lancuch>: wymienny paratert przekazywania tekstu
    <przerwanie>: obsluga przerwania:
                  0-Enter; 1-Esc; 10-Page_Up; 11-Page_Down; 12-F1
    <rodzaj>: 0-wszystkie znaki bez przerwan;
              1-bez znakow plikowych bez przerwan
              3-wszystkie znaki oraz dodatkowe przerwania dla przyciskow:
                F1, Page_Up, Page_Down itp.
             99-dziala tak jak <rodzaj>=3 lecz przerywa praca juz
                po wpisanui chociaz jednego znaku
                zwracajac kod przerwania 99 (do obslugi zmian)
}
          Var znk: Char; {Tymczasowy znak}
              pozycja: Byte; {Aktualna pozycja kursora.
              Uwaga! <pozycja> zaczyna sie od 1 nie od 0 !!
              tzn. zmiany dotyczace 8-go znaku to pozycja 9 !!!}

          Begin
          przerwanie:= 0;
          znk:= Char(7); {Char(7) jest 'pusty' (sygnal dzwiekowy)}
          {dlugosc okna o 1 wieksza od dlugosci tekstu, bo kursor
           zawsze z prawej, wiec musi sie zmiesci za ostatnim znakiem}
          Window (x, y, x+l, y);
          TextBackGround (7);
          TextColor (0);
          ClrScr;
          {wyswietlenie dotychczasowego tekstu zmiennej <lancuch>}
          NapisXY (1, 1, lancuch, 0, 99);
          pozycja:= (Length(lancuch) + 1);
          {glowna petla obslogi klawiatury}
          Repeat
             znk:= ReadKey;
             Case znk Of
                '[': znk:= '';
                ']': znk:= '';
                '=': znk:= '';
                '{': znk:= '';
                '}': znk:= '';
                '+': znk:= '';
                '\': znk:= '';
                Char(8): {Co przy nacisnieciu BackSpace}
                     Begin
                     {sprawdza czy nie jestesmy na poczatku}
                     If pozycja > 1 Then
                        Begin
                        Delete(lancuch, pozycja-1, 1);
                        Dec(pozycja);
                        End;
                     If rodzaj=99 Then przerwanie:=99;
                     End;
                Char(0): {dwoznakowe, czyli: strzalki, delete itp.}
                     Begin
                     znk:= ReadKey;
                     Case znk Of
                            {sprawdza czy nie jestesmy na poczatku tekstu}
                {lewo} 'K': If pozycja > 1 Then Dec(pozycja);
                            {sprawdza czy nie jestesmy na koncu tekstu}
               {prawo} 'M': If pozycja <= Length(lancuch) Then
                               Inc(pozycja);
                {home} 'G': pozycja:= 1;
                 {end} 'O': pozycja:= (Length(lancuch) + 1);
                 {del} 'S': Begin
                            Delete(lancuch, 1, Length(lancuch));
                            pozycja:= 1;
                            If rodzaj=99 Then przerwanie:=99;
                            End;
           {Page_Down} 'I': If (rodzaj = 3) Or (rodzaj = 99) Then
                               przerwanie:=10;
             {Page_Up} 'Q': If (rodzaj = 3) Or (rodzaj = 99) Then
                               przerwanie:=11;
                  {F1} ';': If (rodzaj = 3) Or (rodzaj = 99) Then
                               przerwanie:=12;
                  {F2} '<': If (rodzaj = 3) Or (rodzaj = 99) Then
                               przerwanie:=13;
                        End;{Case}
                     znk:= Char(7);
                     End;
       {Ctrl+A}  Char(1): If (rodzaj = 3) Or (rodzaj = 99) Then
                             przerwanie:=22;
       {Ctrl+S} Char(19): If (rodzaj = 3) Or (rodzaj = 99) Then
                             przerwanie:=21;
       {Ctrl+D}  Char(4): If (rodzaj = 3) Or (rodzaj = 99) Then
                             przerwanie:=24;
       {Ctrl+F}  Char(6): If (rodzaj = 3) Or (rodzaj = 99) Then
                             przerwanie:=23;
          {Tab}  Char(9): If (rodzaj = 3) Or (rodzaj = 99) Then
                             znk:= Char(13);

                Char(27): {Obsluga ESC}
                     Begin
                     przerwanie:=1;
                     End;
                ' ', '/', ':', ';', '*', '?', '"', '<', '>', '|', '.', ',':
                {gdy <rodzaj>=1 nie dopisuje tych znakow}
                     Begin
                     If rodzaj = 1 Then
                        Begin
                        {rysuje odpowiedni status i przywraca okno}
                        Rysuj_status(7);
                        TextBackGround (7);
                        TextColor (0);
                        Window (x, y, x+l, y);
                        znk:= Char(7);
                        End;
                     End;

             End; {case}
             {przy przekroczeniu <l> nie czyta wiecej znakow}
             If znk > Char(31) Then
                If Length(lancuch)=l Then znk:= Char(7);
             {zwykle znaki (czyli od 32) - dopisz i zwieksz pozycje}
             If znk > Char(31) Then
                Begin
                Insert(znk, lancuch, pozycja);
                inc(pozycja);
                {przerywa gdy rodzaj 99}
                If rodzaj = 99 Then przerwanie:=99;
                End;
             NapisXY (1, 1, lancuch, 0, 99);
             ClrEol;
             GotoXY (pozycja, 1);
             {gdy ktores z przerwan wywolane, koniec pracy}
             If przerwanie > 0 Then znk:= Char(13);
          Until znk = Char(13); {Enter}
          End; {procedure}


End.