{
  Modul Paski programu iTiczer.
  Zawiera procedury rysowania paskow menu i paska stanu
  oraz opcji paska menu.
}

Unit Paski;


 Interface
{=========}

Uses Crt, Podstawa;

Procedure Rysuj_menu (rodzaj: Byte);
Procedure Rysuj_opcje_menu (var wybr_poz: String; x: Byte;
                            opc1, opc2, opc3, opc4, opc5: String);
Procedure Rysuj_status (rodzaj: Byte);

Procedure Przyciski_pytania(
          var przerwanie: Byte;
          x, y: Byte;
          przycisk1: String;
          przerwa1: Byte;
          przycisk2: String;
          przerwa2: Byte;
          przycisk3: String;
          kolor, tlo_nieaktywne, tlo_aktywne: Byte);



 Implementation
{==============}

Procedure Rysuj_menu (rodzaj: Byte);
{   Rysuje gorny pasek manu.
    <rodzaj>: 1..3 - podswietla aktualnie wybrana pozycje.
              10   - wypisanie tylo pozycji 'slownik'
              11   - podswietlenie pozycji 'slownik'
              40   - samo Esc
              41   - podswietlone Esc

}
          Begin
          Window(1,1,80,1);
          TextBackGround(6);
          TextColor(1);
          ClrScr;

          If rodzaj < 10 Then
             Begin
             NapisXY (02,1, 'F1: Sowniki', 0, 6);
             NapisXY (19,1, 'F2: Nauka', 0, 6);
             NapisXY (33,1, 'F3: Pomoc ', 0, 6);
             End;
          If (rodzaj > 9) and (rodzaj < 40) Then
             Begin
             NapisXY (02,1, 'F1: Sownik', 0, 6);
             NapisXY (19,1, 'F2: Swko', 0, 6);
             End;

          NapisXY (68,1, 'Esc: Wyjcie', 0, 6);
          Case rodzaj Of
               0,10: Begin End;
               1: NapisXY (02,1, 'F1: Sowniki', 0, 7);
               2: NapisXY (19,1, 'F2: Nauka', 0, 7);
               3: NapisXY (33,1, 'F3: Pomoc', 0, 7);
               4,41: NapisXY (68,1, 'Esc: Wyjcie', 0, 7);
               12: NapisXY (02,1, 'F1: Sownik', 0, 7);
               13: NapisXY (19,1, 'F2: Swko', 0, 7);
               End;
          End;



Procedure Rysuj_opcje_menu (var wybr_poz: string; x: Byte;
                            opc1, opc2, opc3, opc4, opc5: String);
{   Procedura odpowiedzialna za wyswietlanie rozwijanych list opcji menu.
    Po zakonczeniu dzialania przywraca pierwotny wyglad ekranu.
    <wybr_poz> - wymienny parametr do przekazania wyboru
    <x> - odleglosc od lewej krawedzi ekranu
    <opc1..5> - nazwy pozycji do wyswietlenia (puste przekarz jako '');
}
          Var ile_pozycji, i: Byte;
              klaw: Char;
              pozycje: array [1..5] of String[20];
          Begin
          ile_pozycji:=0;
          pozycje[1]:= opc1;
          pozycje[2]:= opc2;
          pozycje[3]:= opc3;
          pozycje[4]:= opc4;
          pozycje[5]:= opc5;
          {nadanie odpowiedniej wartosci zmiennej <ile_pozycji>}
          For i:=1 To 5 Do
              Begin
              If Length(pozycje[i]) > 0 Then Inc(ile_pozycji);
              End;
          {wyrysowanie ramki wybranego menu}
          Boksik (x, 2, x+19, 3+ile_pozycji, '', 1, 1, 7, 1);
          {wypisanie wrzyskich pozycji bez zaznaczenia}
          For i:=1 To ile_pozycji Do
              Begin
              Rysuj_pozycje (x+1, 2+i, 17, ' ' + pozycje[i], 0, 7);
              End;
          {zaznaczenie pierwszej pozycji}
          Rysuj_pozycje (x+1, 3, 17, ' ' + pozycje[1], 15, 1);
          {odpowiedni status}
          Rysuj_status(1);
          i:=1;
          {glowna petla obslogi klawiatury}
          Repeat
          klaw:= ReadKey;
          Case klaw Of
            Char(0): {kursony przekazuja najpier ten znak, potem drogi znak}
               Begin
               klaw:= ReadKey;
                   Case klaw Of
                   'P': Begin {Dol}
                        {wyczyszczenie podwsietlenia poprzedniej pozycji}
                        Rysuj_pozycje (x+1,3+(i-1),17,' '+pozycje[i],0,7);
                        {zapentlenie do poczatku}
                        If i=ile_pozycji Then i:=0;
                        {podwsietlenie nowej pozcji}
                        Rysuj_pozycje (x+1,3+i,17,' '+pozycje[i+1],15,1);
                        Inc(i);
                        Rysuj_status(1);
                        {aktualizacja parametru wymiennego <wybr_poz>}
                        Str(i, wybr_poz);
{dla debugowania}          {NapisXY (2,24,wybrana_pozycja,1,3);}
                        End;
                   'H': Begin {Gora}
                        Rysuj_pozycje (x+1,3+(i-1),17,' '+pozycje[i],0,7);
                        If i=1 Then i:= ile_pozycji+1;
                        Rysuj_pozycje (x+1,3+(i-2),17,' '+pozycje[i-1],15,1);
                        Dec(i);
                        Rysuj_status(1);
                        Str(i,wybr_poz);
{dla debugowania}          {NapisXY (2,24,wybrana_pozycja,1,3);}
                        End;
                   'K': Begin {Lewo}
                        wybr_poz:='lewo';
                        klaw:= Char(27);
                        End;
                   'M': Begin {Prawo}
                        wybr_poz:='prawo';
                        klaw:= Char(27);
                        End;
                   End;
               End;
            Char(13): Begin {enter}
                      Str(i,wybr_poz);
                      klaw:= Char(27);
                      End;
            Char(27): wybr_poz:='brak'; {Esc}
          End;
          Until klaw= Char(27); {wyjscie z petli przy nacisnieciu Esc}
          {przywrocenie pierwotniego wygladu ekranu}
          Szare_tlo_czesc (x, 2, x+19, 3+ile_pozycji);
          Rysuj_status(1);
          End;


Procedure Rysuj_status (rodzaj: Byte);
{   Procedura wyswietlania paska stanu.
    <rodzaj> - numer identyfikujacy dany pasek stanu.
}
          Begin
          {czyszczenie paska stanu}
          Window(1,25,80,25);
          TextBackGround(3);
          TextColor(0);
          ClrScr;
     {wyswietlanie paska stanu zaleznie od parametru <rodzaj>}
     Case rodzaj of
     1: NapisXY (02, 1, 'Wybierz ktr z opcji.', 0, 99);
     2: NapisXY (02, 1,
        'Podaj nazw sownika, ktry chcesz utwoy. (max 8 znakw)',
         0, 99);
     3: NapisXY (02, 1, 'Nie dokonano zmian.', 0, 99);
     4: Begin
        NapisXY (02, 1,
                '<-, ->: Wybr opcji     Enter: Zatwierdz     Esc: Anuluj',
                0 ,99);
        NapisXY (69, 1, ' Koniec...', 0, 99);
        End;
     41: NapisXY (02, 1,
        'S: Zapisz      K: Zakocz      ESC: Anuluj',
        0 ,99);
     5: NapisXY (02, 1, 'Plik utworzony.', 0, 99);
     6: NapisXY (02, 1, 'Opisz tematyk nowego sownika. (max 40 znakw)',
        0, 99);
     7: NapisXY (02, 1,
        'W nazwie pliku nie moga pojawia si takie znaki jak: \/:;*?<>|.,',
        0, 99);
     8: Begin
        NapisXY (02, 1, 'Nacinij dowolny klawisz.', 0, 99);
        NapisXY (70, 1, ' Pomoc...', 0, 99);
        End;
     81:Begin
        NapisXY (02, 1, 'Pg_Up: Poprzed. strona    Pg_Down: Nast. strona', 0, 99);
        NapisXY (70, 1, ' Pomoc...', 0, 99);
        End;
     9: NapisXY (02, 1, 'Procedura anulowana.', 0, 99);
     10:Begin
        NapisXY (02, 1, 'Pg_Up, Pg_Down: Przewi', 0, 99);
        NapisXY (30, 1, 'Del: Usu', 0, 99);
        NapisXY (53, 1, ' Wybierz sownik z listy.', 0, 99);
        End;
     12:NapisXY (02, 1, 'OK. Zmiany zapisane.', 0, 99);
     13:NapisXY (02, 1, 'Bd. Zapis nie powid si.', 0, 99);
     21:Begin;
        NapisXY (02, 1, 'Pg_Up,Pg_Down: Midzy swkami', 0, 99);
        NapisXY (34, 1, 'Tab,Enter: Midzy pozycjami', 0, 99);
        NapisXY (64, 1, ' Edytor swek', 0, 99);
        End;
     31:Begin
        NapisXY (02,1,
                'Wpisz odpowied, poczym zatwierd klawiszem Enter.',0,99);
        NapisXY (72, 1, ' Nauka', 0, 99);
        End;
     33:NapisXY (02, 1, 'Nacinij dowolny kawisz.', 0, 99);
            End;
          {przeniesienie kursora w prawy dolny rog ekranu}
          TextColor(3);
          NapisXY (80,1, '', 0, 99);
          End;


Procedure Przyciski_pytania(
{wane, e <przerwanie> nie tylko zwraca warto wybranego guzika,
 ale otrzymuje te ktry guzik jest domylnie zaznaczony!}
          var przerwanie: Byte;
          x, y: Byte; {x jest pozycj koca!!!}
          przycisk1: String; {a pozycje numerowane od prawej!!!}
          przerwa1: Byte;
          przycisk2: String;
          przerwa2: Byte;
          przycisk3: String; {ta pozycja jest zatem najblizej lewej}
          kolor, tlo_nieaktywne, tlo_aktywne: Byte);

   Var
      i, ile: Byte;
      klaw: Char;
      xx: array[1..3] of Byte;
      przycisk: array [1..3] of String;

   Begin
   przycisk[1]:= przycisk1;
   przycisk[2]:= przycisk2;
   przycisk[3]:= przycisk3;

   xx[1]:= x - Length(przycisk1);
   xx[2]:= xx[1] - przerwa1 - Length(przycisk2);
   xx[3]:= xx[2] - przerwa2 - Length(przycisk3);

   {upewnijmy sie, ze nie pracujemy na bzdurach}
   If przycisk3 = '' Then Ile:= 2
      Else Ile:= 3;
   If przerwanie <> ( 1 or 2 or 3) Then przerwanie:= 1;

   TextColor (kolor);
   For i:= 1 To ile Do
       Begin
       If i =  przerwanie Then
          NapisXY (xx[i], y, przycisk[i], 1, tlo_aktywne)
       Else
          NapisXY (xx[i], y, przycisk[i], 1, tlo_nieaktywne)
       End;
   Rysuj_status(4);

   Repeat
      klaw:= ReadKey;
      Case klaw Of
      Char(0): Begin
              klaw:= ReadKey;
              Case klaw Of
      {lewo}  Char(75): If przerwanie < ile Then
                       Begin
                       TextColor(15);
                       NapisXY (xx[przerwanie], y,
                                przycisk[przerwanie], 1, tlo_nieaktywne);
                       Inc(przerwanie);
                       NapisXY (xx[przerwanie], y,
                                przycisk[przerwanie], 1, tlo_aktywne);
                       Rysuj_status(4);
                     End; {Char(75) lewo}
     {prawo}  Char(77): If przerwanie > 1 Then
                       Begin
                       TextColor(15);
                       NapisXY(xx[przerwanie], y,
                                przycisk[przerwanie], 1, tlo_nieaktywne);
                       Dec(przerwanie);
                       NapisXY (xx[przerwanie], y,
                                przycisk[przerwanie], 1, tlo_aktywne);
                       Rysuj_status(4);
                    End; {Char(77) prawo}
              End; {Case}
              End; {Char(0)}

      Char(27): Begin
                przerwanie:= 1;
                klaw:= Char(13);
                End;
      End; {Case klaw}
   Until klaw = Char(13); {Enter}
   End;


End.